import json
import time

def total_vocabulary():
    #Return list with all the words indexes
    with open('json/categories.json') as json_data:
        categories_dict = json.load(json_data)
    categories=categories_dict.keys()
    vocabulary=[]
    for i in categories:
        with open('json/categories/'+i+'.json') as json_data:
            category = json.load(json_data)    
        for j in category.keys():
            word=i+","+j
            vocabulary.append(word)
    return vocabulary

def worst_word():
    #Return coordinate of the worst word
    with open('json/words_learned.json') as json_data:
        total = json.load(json_data)
    words_learned_list=words_learned()
    coefficient=0
    index="0,0"
    for i in words_learned_list:
        word_coefficient=total[i][0][0]/total[i][0][1]
        if coefficient==0:
            coefficient=word_coefficient
            index=i
        elif coefficient!=0 and word_coefficient<coefficient:
            coefficient=word_coefficient
            index=i
    worst_word=index
    return worst_word
    
def today_date():
    today=time.localtime()
    today_formated=[today[0],today[1],today[2]]
    return today_formated

def categories_keys():
    #Return a list of the categories (index)
    with open('json/categories.json') as json_data:
        categories = json.load(json_data)
    return categories.keys()

def words_learned():
    #Return a list of keys of words learned
    with open('json/words_learned.json') as json_data:
        total = json.load(json_data)
    words_learned=list(total.keys())
    return words_learned

def words_learned_dict():
    #Return dictionary of words learned
    with open('json/words_learned.json') as json_data:
        total = json.load(json_data)
    return total

class Vocabulary:
    def __init__(self):
        self.all=total_vocabulary()
        self.worst_word=worst_word()
        self.words_learned_dict=words_learned_dict()
        self.categories=categories_keys()
        self.words_learned=words_learned()
    def add_word_learned(self,word):
        learned_dict=words_learned_dict()
        date_learned=time.localtime()
        date_learned_formated=[date_learned[0],date_learned[1],date_learned[2]]
        learned_dict[word]=[[1,1],date_learned_formated,1]
        with open('json/words_learned.json','w') as json_data:
            json.dump(learned_dict,json_data)    
        self.words_learned=words_learned()
        self.words_learned_dict=words_learned_dict()
    def update_word_learned(self,word,values):
        learned=words_learned_dict()
        status_before=learned[word]
        today=today_date()
        status=[values,today,status_before[2]]
        learned[word]=status
        with open('json/words_learned.json','w') as json_data:
            json.dump(learned,json_data)
